# Mission Portal

## Development Environment Setup

```make quickstart```

This will download and setup a vagrant setup for development where changes in this project directory
will be automatically synced to the hub htdocs when you run

```make autosync```

For this setup Mission Portal is available at https://localhost:9002, default user/pass is admin/admin.

## Testing

There are many testing suites in Mission Portal. Docs on all are TODO.

To run phpunit tests on Travis (debug mode):
```cd .. && git clone -b $TRAVIS_BRANCH git@github.com:cfengine/buildscripts.git```
```mission-portal/travis.sh```

In case of segfault you can analyze a coredump:
```rm -rf tmp```
```mkdir tmp```
```apport-unpack /var/crash/_var_cfengine_httpd_bin_httpd.0.crash tmp```
```gdb /var/cfengine/httpd/bin/httpd tmp/CoreDump```

### JavaScript Unit Tests (jest style)

First install all npm modules needed

```npm i```

Jest monitors the filesystem for changes and automatically runs with coverage any tests/files that
change. This is the mode for development.

```npm test```

For CI I have added a 'ci' script in package.json which runs all tests once and adds Jest's CI
behavior which is more appropriate. Coverage is printed to STDOUT as well as added in lcov.info,
lcov-report/**, clover.xml and coverage-final.json for parsing by CI systems.

```npm run ci```

## Build Status

[![Build Status](https://travis-ci.com/cfengine/mission-portal.svg?token=gW6Z3m1qhfPuxM9wLsVx&branch=master)](https://travis-ci.com/cfengine/mission-portal)
