<?php

//class autocomplete extends Cf_Controller

require_once APPPATH . '/libraries/Cf_REST_Controller.php';

class autocomplete extends Cf_REST_Controller
{

    protected $username = '';

    function __construct()
    {
        parent::__construct();
        $this->load->model(array('advancedreports_model'));
        $this->advancedreports_model->setRestClient($this->getRestClient());
        $this->username = $this->session->userdata('username');
    }

    function index()
    {
        $this->respond_forbidden();
    }

    /**
     * Return field data for autocomplete list
     *
     * Request body contain:
     *  $fieldName - type of variable - package name, version number...
     *  $value - value from input field
     *  $parentFieldName  - type(sqlfield name) of parent element - 'patchname'
     *  $parentValue - value of parent element - in case list depends on parent value, for example - package version depends on package name
     */
    function load_post()
    {
        $data = json_decode($this->request->body, true);

        $fieldName = $data['type'];
        $value     = $data['value'];

        $parentFieldName = isset($data['parentType'])  ?  $data['parentType']  : '';
        $parentValue     = isset($data['parentValue']) ?  $data['parentValue'] : '';

        try {
            $result = $this->advancedreports_model->getAutocompleteFieldData($this->username, $fieldName, $value, $parentFieldName, $parentValue);
        }
        catch(Exception $e)
        {
            $message = $e->getMessage();
            log_message('error', 'load_get(): Unable to get autocomplete list for '. $fieldName .', error: ' . $message);
            respond_internal_error($message);
            return;
        }

        respond_ok(json_encode($result));
    }

}
