<?php
require_once APPPATH . 'libraries/Cf_REST_Controller.php';

class Scriptsapi extends Cf_REST_Controller
{

    function __construct()
    {
        parent::__construct();

        $this->load->model('alerts_model');
        $this->username = $this->session->userdata('username');
    }


    //$rulesIds - can be urlencoded comma separated list
    function scripts_get($id = null)
    {
        try
        {
            $result = $this->alerts_model->getAllNotificationScripts($id);

            if (empty($result)) {
                $message = $this->lang->line('dashboard_scripts_not_exist');
                log_message('debug', 'Failed retrieving rule, error: ' . $message);
                respond_not_found(json_encode($message));
                return;
            }

            $json = json_encode($result);
            respond_ok($json);
        }
        catch(Exception $e)
        {
            $message = $e->getMessage();
            log_message('debug', 'Failed retrieving scripts, error: ' . $message);
            respond_internal_error($message);
        }
    }
 }
