<?php

class DashboardsExporter extends BaseDataExporter
{
    public function isOnlyForAdmin(): bool
    {
        return false;
    }


    public function getData(): array
    {
        $this->addScriptsToArchive();
        $result = [];

        $this->db->reset_query();
        if ($this->exportOnlyUserItems == true  || !$this->isAdmin) {
            $filter = ['username' => $this->username];
            $result['dashboard_dashboards'] = $this->db->get_where('dashboard_dashboards', $filter)->result_array();
            $result['dashboard_widgets'] = $this->db->get_where('dashboard_widgets', $filter)->result_array();
            $result['dashboard_alerts'] = $this->db->get_where('dashboard_alerts', $filter)->result_array();
            $result['dashboard_rules'] = $this->db->get_where('dashboard_rules', $filter)->result_array();
            $result['dashboard_scripts'] = $this->db->get('dashboard_scripts')->result_array();
            $result['dashboard_alerts_script'] = $this->db->get("dashboard_alerts_script")->result_array();
        } else {
            $result['dashboard_dashboards'] = $this->db->get('dashboard_dashboards')->result_array();
            $result['dashboard_widgets'] = $this->db->get('dashboard_widgets')->result_array();
            $result['dashboard_alerts'] = $this->db->get('dashboard_alerts ')->result_array();
            $result['dashboard_rules'] = $this->db->get('dashboard_rules')->result_array();
            $result['dashboard_scripts'] = $this->db->get('dashboard_scripts')->result_array();
            $result['dashboard_alerts_script'] = $this->db->get('dashboard_alerts_script')->result_array();
        }

        return ['data' => json_encode($result), 'info' => sprintf('%s, Widgets: %s , Alerts: %s, Rules: %s', sizeof($result['dashboard_dashboards']), sizeof($result['dashboard_widgets']), sizeof($result['dashboard_alerts']), sizeof($result['dashboard_rules']))];
    }
}
